values = {} --[current,last]
for i = 1, statNum do
  local t = tonumber(GlobalsGetValue(trackedStats[i]))
  values[trackedStats[i]] = {}
  values[trackedStats[i]]["current"] = t
  values[trackedStats[i]]["last"] = t
end

dataString = GlobalsGetValue("dataString")

------------------------------------------- Gets start -------------------------------------------
local function getPlayerPos()

	if not player then
		local camx,camy = GameGetCameraPos()
		return camx, camy
	end
	return EntityGetTransform(player)
end

local function getPlayerHealth()
  local comp 
  if values["polymorphed"]["current"] ~= nil and EntityGetComponent(values["polymorphed"]["current"], "DamageModelComponent") ~= nil then
    comp = EntityGetComponent(values["polymorphed"]["current"], "DamageModelComponent")[1]
  else
    if not EntityGetIsAlive(player) then return 0,0 end
    if not player then return end
    comp = EntityGetComponent(player, "DamageModelComponent")[1]
  end
  return math.floor(ComponentGetValue2(comp, "hp")*25), math.floor(ComponentGetValue2(comp, "max_hp")*25)
end

local function getPlayerMoney()
  if values["polymorphed"]["current"] ~= nil then return values["money"]["last"] end
  if not player then return end
  local comp = EntityGetComponent(player,"InventoryGuiComponent")[1]
  return ComponentGetValue2(comp, "wallet_money_target")
end
------------------------------------------- Gets end -------------------------------------------

local function hasValueChanged()
  local changed = false
  for i = 1, statNum do
    if graphStat[i] then
      if values[trackedStats[i]]["current"] ~= values[trackedStats[i]]["last"] then
        values[trackedStats[i]]["last"] = values[trackedStats[i]]["current"] 
        GlobalsSetValue(trackedStats[i], tostring(values[trackedStats[i]]["current"]))
        changed = true
      end
    end
  end
  return changed
end

local function saveToDataString() 
  local str = "~"
  local function addNil()
    str = str.."_-1"
  end
  for i = 1, statNum do
    if values[trackedStats[i]]["current"] and values[trackedStats[i]]["current"] ~= nil then 
      if i > 1 then str = str.."_" end
      str = str..values[trackedStats[i]]["current"]
    else 
      addNil()
    end
  end
  dataString = dataString..str
end 

function stat_tracker_main()

  player = (EntityGetWithTag("player_unit") or {})[1]

  if not player then values["polymorphed"]["current"] = find_polymorphed_players()[1] else values["polymorphed"]["current"] = nil end

  if values["playtime"]["current"] == nil or values["polymorphed"]["current"] or EntityGetIsAlive(player) or values["health"]["current"] > 0 then values["playtime"]["current"] = StatsGetValue("playtime") end

  if values["playtime"]["last"] ~= math.floor(values["playtime"]["current"]) then
    values["playtime"]["last"] = math.floor(values["playtime"]["current"])
    values["health"]["current"], values["max_health"]["current"] = getPlayerHealth()
    values["money"]["current"] = getPlayerMoney()
    values["orbs"]["current"] = GameGetOrbCountThisRun()
    values["kills"]["current"] = StatsGetValue("enemies_killed")
    if hasValueChanged() or (values["polymorphed"]["current"] ~= nil and not values["polymorphed"]["last"]) or (values["polymorphed"]["current"] == nil and values["polymorphed"]["last"]) then
      saveToDataString()
      GlobalsSetValue("dataString", dataString)
      values["polymorphed"]["last"] = values["polymorphed"]["current"] ~= nil
    end
  end
end