
local gui = GuiCreate()

------------------------------------------- Graph variable begin -------------------------------------------
local g_x = 1
local g_y = 1
local g_yUp = {1,10,60,600,3600,86400,604800,31449600,314496000} 
local g_yTitle = {" sec","0 sec"," min","0 min"," hr"," day"," week"," year","0 year"} --becuase why not plan for that one person out there that is a god
local blip_x
local blip_y = 4
local invOpen = false
------------------------------------------- Graph variable end -------------------------------------------

------------------------------------------- Color begin ------------------------------------------
colors = {}
colors["health"] = {(135/255),(191/255),(28/255),1}
colors["max_health"] = {(106/255),(44/255),(35/255),1}
colors["money"] = {(237/255),(179/255),(68/255),1}
colors["polymorphed"] = {(180/255),(104/255),(176/255),1}
colors["max_polymorphed"] = {(136/255),(59/255),(132/255),1}
colors["orbs"] = {(40/255),(96/255),(150/255),1}
colors["kills"] = {(220/255),0,0,1}
colors["black"] = {0,0,0,1}

function colorNext(c)
  if not colors[c] then return false end
  GuiColorSetForNextWidget(gui,colors[c][1],colors[c][2],colors[c][3],colors[c][4])
  return true
end
------------------------------------------- color end -------------------------------------------

------------------------------------------- Generic Draw begin -------------------------------------------


function draw_line_horizontal(x,y,l,c)
  colorNext(c)
  GuiImage( gui, 1, x, y, pixel, 1, l, 1)
end
function draw_line_vertical(x,y,l,c)
  colorNext(c)
  GuiImage( gui, 1, x, y, pixel, 1, 1, l)
end
function draw_line(x1,y1,x2,y2,c)
  if (x1 ~= x2) and (y1 ~= y2) then
    local mx = (x1+x2)/2
    local my = (y1+y2)/2
    draw_line(x1,y1,math.floor(mx),math.floor(my),c)
    draw_line(math.ceil(mx),math.ceil(my),x2,y2,c)
  else
    if (x1 == x2) and (y1 == y2) then
      draw_line_horizontal(x1,y1,1,c)
    else
      if y1 == y2 then
        draw_line_horizontal(x1,y1,x2-x1+1,c) -- +1 makes it extend past where it should somtimes but is always too short without
      end
      if x1 == x1 then
        draw_line_vertical(x1,y1,y2-y1+1,c)
      end
    end
  end
end
function draw_square(x,y,w,h,c,f)
  if f ~= nil then 
    colorNext(c)
    GuiImage( gui, 1, x, y, pixel, 1, w, h)
  else
    draw_line_horizontal(x,y,w,c)
    draw_line_horizontal(x,y+h,w,c)
    draw_line_vertical(x,y,h,c)
    draw_line_vertical(x+w,y,h,c)
  end
end

------------------------------------------- Generic Draw begin -------------------------------------------

------------------------------------------- Graph Draw begin -------------------------------------------

local function drawToggles(x,y,n)
  local x_total = 10
  GuiZSet(gui,graphZ)
  for i = 1, n do
    if shown[i] then colorNext(trackedStats[i]) end
    if GuiButton(gui,i,x + x_total,y,"     "..displayedStats[i]) then
      shown[i] = not shown[i]
    end
    if shown[i] then 
      draw_square(x+x_total,y,10,10,trackedStats[i],1)
    else
      draw_square(x+x_total,y,10,10)
    end
    x_total = x_total + 15 + #(displayedStats[i]) * 5
  end
end

local function draw_graph(x,y,w,h)
  if not shown[stat["playtime"]] then 
    drawToggles(x + w - 50 ,y,1)
    return 
  else
    drawToggles(x,y - h - 15,statNum)
  end
  GuiZSet(gui,graphZ)
  draw_line_horizontal(x,y,w)
  draw_line_vertical(x,y,-h)

  local data = loadFromDataString()
  local length = #(data)
  local y_limit = 0
  local top = {}
  local blipNum_x = 60 -- change it to be baised off the size rather than a set amount?
  local blipNum_y = 10 -- ^^^

  local function colorPolyCheck(c,i)
    if shown[stat["polymorphed"]] and (trackedStats[c] == "health" or trackedStats[c] == "max_health") and data[i][stat["polymorphed"]] ~= nil and tonumber(data[i][stat["polymorphed"]]) > 0 then --health or max health and poly
      if trackedStats[c] == "health" then 
        colorNext("polymorphed") 
      end
      if trackedStats[c] == "max_health" then 
        colorNext("max_polymorphed") 
      end
    else
      colorNext(trackedStats[c])
    end
  end

  for c = 1, statNum do
    if shown[c] and graphStat[c] then
      for i = 1, length do
        if data[i][c] and data[i][c] ~= "?" then
          if not ( not shown[stat["polymorphed"]] and (trackedStats[c] == "health" or trackedStats[c] == "max_health") and data[i][stat["polymorphed"]] ~= nil and tonumber(data[i][stat["polymorphed"]]) > 0) then
            if y_limit == nil or y_limit < tonumber(data[i][c]) then y_limit = tonumber(data[i][c]) end
          end
        end
      end
    end
  end

  playtime = values["playtime"]["current"]

  --blip_x start
  if playtime / g_yUp[g_x] > blipNum_x then
    g_x = g_x + 1
  end
  for i = 1, blipNum_x do
    if ((g_yUp[g_x]*i)/playtime)*w > w then
      break
    end
    if g_yUp[g_x]*i % g_yUp[g_x+1] == 0 then
      blip_x = -4
      GuiText(gui,x - 10 + ((g_yUp[g_x]*i)/playtime)*w,y+10,(g_yUp[g_x]*i)/g_yUp[g_x+1]..g_yTitle[g_x+1])
    else
      blip_x = -2
    end
    draw_line_vertical(x + ((g_yUp[g_x]*i)/playtime)*w,y,blip_x)
  end
  --blip_x end

  --blip_y start
  g_y = math.floor(y_limit / blipNum_y)
  if y_limit < blipNum_y then
    blipNum_y = y_limit
  end
  for i = 1, blipNum_y do
    draw_line_horizontal(x,y -  (i * (h/blipNum_y)),blip_y)
    GuiText(gui,x - 5 - (#(tostring(i * g_y))*charSize), y - 5 -  (i * (h/blipNum_y)), math.floor(i * (y_limit/blipNum_y)))
  end
  --blip_y end

  for c = 1, statNum do
    if shown[c] and graphStat[c] then
      GuiZSet(gui,graphZ+c)
      for i = 1, length do
        if data[i][c] and  data[i][c] ~= nil and data[i][c] ~= "?" then
          data[i][c] = tonumber(data[i][c])
          if not ( not shown[stat["polymorphed"]] and (trackedStats[c] == "health" or trackedStats[c] == "max_health") and data[i][stat["polymorphed"]] ~= nil and tonumber(data[i][stat["polymorphed"]]) > 0) then
            if i + 1 <= length then
              if trackedStats[c] and trackedStats[c] ~= nil then
                local drawn = false
                for t = 1, length-i do
                  if not ( not shown[stat["polymorphed"]] and (trackedStats[c] == "health" or trackedStats[c] == "max_health") and data[i+t][stat["polymorphed"]] ~= nil and tonumber(data[i+t][stat["polymorphed"]]) > 0) then
                    colorPolyCheck(c,i)
                    if data[i][c] >=0 then draw_line_horizontal(math.floor(x+(data[i][1]/playtime)*w),math.floor(y-(data[i][c]/y_limit)*h),math.ceil(((data[i+t][1]-data[i][1])/playtime)*w)) end
                    colorPolyCheck(c,i+t)
                    draw_line_vertical(math.floor(x+(data[i+t][1]/playtime)*w),math.floor(y-(data[i+t][c]/y_limit)*h),math.ceil(((data[i+t][c]-data[i][c])/y_limit)*h))
                    drawn = true
                    break
                  end
                end
                if not drawn then
                  colorPolyCheck(c,i)
                  if data[i][c] >=0 then draw_line_horizontal(x+(data[i][1]/playtime)*w,y-(data[i][c]/y_limit)*h,((playtime-data[i][1])/playtime)*w) end
                end
              end
            else
              if trackedStats[c] and trackedStats[c] ~= nil then
                colorPolyCheck(c,i)
                if data[i][c] >=0 then draw_line_horizontal(x+(data[i][1]/playtime)*w,y-(data[i][c]/y_limit)*h,((playtime-data[i][1])/playtime)*w) end
              end
            end
          end
        end
      end
    end
  end
  --background begin
  local extend_x = #(tostring(y_limit))*charSize + 10
  GuiZSet(gui,graphZ+statNum+2)
  draw_square(x - extend_x,y-h - 20,w+5+extend_x,h + 40,"black",1)
  GuiZSet(gui,graphZ)
  draw_square(x - extend_x,y-h - 20,w+5+extend_x,h + 40)
  --background end
end


------------------------------------------- Graph Draw end -------------------------------------------

function ui_main()
  screen_x, screen_y = GuiGetScreenDimensions(gui)
  if invOpen ~= isInvOpen() then
    invOpen  = isInvOpen()
    if invOpen and ModSettingGet(modName..".GraphInvOpen") then
      shown[stat["playtime"]] = true
    end
    if not invOpen and ModSettingGet(modName..".GraphInvClose")  then
      shown[stat["playtime"]] = false
    end
  end
  draw_graph(screen_x*(25/100),screen_y*(90/100),screen_x*(7/10),screen_y*(5/10))

	if gui ~= nil then
		GuiStartFrame(gui)
	end
end